#----------------------------------------------------------------------
#  userpanalForwarding
#----------------------------------------------------------------------

package esmith::FormMagick::Panel::userpanelForwarding;

use strict;
use warnings;
use esmith::AccountsDB;
use esmith::FormMagick;

our @ISA = qw(esmith::FormMagick Exporter);
our $VERSION = sprintf '%d.%03d', q$Revision: 1.0 $ =~ /: (\d+).(\d+)/;
our @EXPORT = qw();

our $db = esmith::AccountsDB->open() or die "Couldn't open AccountsDB\n";;

#get user and untaint
our $UserName = $ENV{'REMOTE_USER'};
$UserName = $1 if ($UserName =~ /^([a-z][\-a-z0-9]*)$/);

sub get_EmailForward
{
    return $db->get_prop($UserName, "EmailForward");
}

sub get_ForwardAddress
{
    return $db->get_prop($UserName, "ForwardAddress");
}

sub validate_email
{
    my $fm = shift;
    my $q = $fm->{cgi};

    my $Forward = $q->param('EmailForward');
    my $ForwardAddress = $q->param('ForwardAddress') || '';
    $ForwardAddress =~ s/^\s+|\s+$//g;

    my $response = $fm->email_simple($ForwardAddress);
    if ($response eq 'OK')
    {   
        return 'OK';
    }
    elsif ($ForwardAddress eq '')
    {   
        return 'OK' if ($Forward eq 'local');
        return 'VALID_EMAIL_NEEDED';
    }
    else
    {   
        return 'UNACCEPTABLE_CHARS';
    }
}

sub change_settings
{
    my $fm = shift;
    my $q = $fm->{cgi};

    $db->set_prop($UserName, 'EmailForward', $q->param("EmailForward"));
    $db->set_prop($UserName, 'ForwardAddress', $q->param("ForwardAddress"));

    unless ( system('/sbin/e-smith/signal-event', "email-update-quick", $UserName ) == 0 )
    {
        $fm->error('ERROR_UPDATING');
        return undef;
    }
    
    $fm->success('SUCCESS');
}

1;
